//-----------------------------------------------------------------
// CONFIGURAES URL E PATHS
//-----------------------------------------------------------------
var Dados = {
    BASE_URL :"./",
    IMG_URL :"./img/"
};

$.fn.extend({
    serializeUni: function() {
		return jQuery.param( this.serializeArrayUni() );
	},

	serializeArrayUni: function() {
        var rselectTextarea = /select|textarea/i;
        var rinput = /text|hidden|password|search/i;
        var rCRLF = /\r?\n/g;
		return this.map(function(){
			return this.elements ? jQuery.makeArray( this.elements ) : this;
		})
		.filter(function(){
			return this.name && !this.disabled &&
				( this.checked || rselectTextarea.test( this.nodeName ) ||
					rinput.test( this.type ) );
		})
		.map(function( i, elem ){
			var val = $(this).uni2ent(jQuery( this ).val());

			return val == null ?
				null :
				jQuery.isArray( val ) ?
					jQuery.map( val, function( val, i ){
						return { name: elem.name, value: val.replace( rCRLF, "\r\n" ) };
					}) :
					{ name: elem.name, value: val.replace( rCRLF, "\r\n" ) };
		}).get();
	},
    uni2ent: function (srcTxt) {
        var entTxt = '';
        var c, hi, lo;
        var len = 0;
        for (var i=0, code; code=srcTxt.charCodeAt(i); i++) {
            var rawChar = srcTxt.charAt(i);
            // needs to be an HTML entity
            if (code > 255) {
                // normally we encounter the High surrogate first
                if (0xD800 <= code && code <= 0xDBFF) {
                    hi  = code;
                    lo = srcTxt.charCodeAt(i+1);
                    // the next line will bend your mind a bit
                    code = ((hi - 0xD800) * 0x400) + (lo - 0xDC00) + 0x10000;
                    i++; // we already got low surrogate, so don't grab it again
                }
                // what happens if we get the low surrogate first?
                else if (0xDC00 <= code && code <= 0xDFFF) {
                    hi  = srcTxt.charCodeAt(i-1);
                    lo = code;
                    code = ((hi - 0xD800) * 0x400) + (lo - 0xDC00) + 0x10000;
                }
                // wrap it up as Hex entity
                c = "&#x" + code.toString(16).toUpperCase() + ";";
            } else {
                c = rawChar;
            }
            entTxt += c;
            len++;
        }
        return entTxt;
    }
});

var mndti = {
    get_post : function(par){
        // SE DADOS TIPO POST, SERIALIZA CAMPOS
        if(par['type'] == 'POST' && par['elf']){ var dataString = $(par['elf']).serializeUni(); }
        
        $.ajax({
            url: Dados.BASE_URL+'cont/ajax.php?querys='+par['querys'],
            dataType: par['dataType'],
            type: par['type'],
            cache: par['cache'],
            data: dataString,
            success: function(data, textStatus){
                // LOADING REMOVE
                mndti.loading_remove();
                // INNER APPEND
                if(par['inner'] == 'append'){ $(par['elr']).append(data); }
                // INNER HTML - PADRAO
                if(par['inner'] == 'html') { $(par['elr']).html(data); }
                
                if(par['inner'] == 'uipop') { mndti.uipop(par, data); }
            },
        });
    },
    uipop : function (par,html){
        
        $('body').after('<div id="'+par['elui'].substring(1)+'"></div>');
        $(par['elui']).html(html);
        
        if(par['uititle']){ par['jtitle'] = par['jtitle']+' ('+par['elui']+')'; }
                
        $(par['elui']).dialog({
            modal: par['uimodal'],
            title : par['jtitle'],
            width: 'auto',
            height: 'auto',
            resizable: false,
            draggable: par['uidraggable'],
            close: function(ev, ui) { $(this).dialog('destroy').remove(); }

        });
    },
    
    click : function (par){
        $('body').on('click', par['el'], function(e){
            // PREVENT ACAO PADRAO
            e.preventDefault();
            par['obj'] = this;
            // PUXA O QUERYSTRING
            par['querys'] = $(this).attr("data-mndti-querys");
            
            // ELEMENTO DE RETORNO
            var dataELR = $(this).attr("data-mndti-elr"); 
            if(dataELR){ par['elr'] = dataELR; } else { par['elr'] = par['elr']; }
            
            // REQUEST GET
            if(par['type'] == 'GET'){
                if(par['inner'] == 'uipop'){
                    par['elui'] = $(this).attr("data-mndti-elui");                    
                    par['jtitle'] = $(this).attr("title");
                    var uiinstanceQ = $(par['elui']).length;
                    if(uiinstanceQ == 0){
                        mndti.loading();
                        mndti.get_post(par);
                    } else {
                        alert('ATENCAO: ja existe uma janela semelhante aberta, voce deve fecha-la antes de abrir uma nova. JANELA: '+par['elui']);
                    }
                } else {
                    mndti.loading();
                    mndti.get_post(par);
                }
            }
            
            // REQUEST POST
            if(par['type'] == 'POST'){
                // ELEMENTO DO FOMULARIO PARA SERIALIZE
                var dataELF = $(this).attr("data-mndti-elf");
                if(dataELF){ par['elf'] = dataELF; } else { par['elf'] = par['elf']; }
                
                mndti.loading();
                mndti.get_post(par);
            }
        });
    },
    teste: function(obj){
        return AutoValidar.valida(obj);        
    },
    remove_elemento : function (el,tag){
        $('body').on('click', el, function(e) {
            e.preventDefault();
            //var el2 = $(this).attr('data-act');
            $(this).parents(tag).empty().hide();
            //$(el2).empty();
        });
    },    
    adicionar_elemento : function(el,el2,tag,html){
        $('body').on('click', el, function(e) {
            e.preventDefault();
            //var i = $(el2+'>'+el3).length+1;               
            $(el2).append('<'+tag+'>'+html+'</'+tag+'>');
            exe.afterFNL();
        });
    },
    
    loading : function(){
        $('body').after('<div id="loading"><div id="ajax_loading"><img src="'+Dados.IMG_URL+'ajax_loading.gif" alt="carregando" /></div></div>');        
    },
    loading_remove : function(){
        $('#loading').remove();
    },
    portal_cats : function(par){
        $(par['el']).on('change', function(){
            // LOADING
            mndti.loading();
            // QUERYSTRING
            par['querys'] = 'cat:portal-select:'+this.value+'-'+$(this ).attr("data-mndti-querys");
            // ELEMENTO DE RETORNO
            var dataELR = $(this).attr("data-mndti-elr"); 
            if(dataELR){ par['elr'] = dataELR; } else { par['elr'] = par['elr']; }
            mndti.get_post(par);
        });
    },
    
    load : function(options){
        var defaults = { inner: 'html', type: 'GET', dataType: 'html', act: 'click', uimodal: false, uititle: true, uidraggable: true, cache: false };        
        var par = $.extend({}, defaults, options);
        
        if(par['act'] == 'onchange'){
            mndti.portal_cats(par);
        }
        if(par['act'] == 'click'){
            mndti.click(par);
        }
    },
    
    
    // EXECUTAR TODAS FUNCOES
    all : function (){
        mndti.load({act: 'onchange', el: '[rel=categoria_ajax]'});
        mndti.load({act: 'click', el:'.cat-gerenciar-inf', inner: 'uipop'});
        mndti.load({ el: '.salvar_dados_categoria', type: 'POST' });
        mndti.adicionar_elemento('.adicionar_op_categoria','#adicionar_op_categoria','p','<input name="dados_categ[]" type="text" value="" /><a href="" class="remove_op_categoria" title="remover este campo">[x]</a>');
        mndti.adicionar_elemento('.adicionar_portal_g','#adicionar_op_categoria','p','<input class="f-portal-id" name="f_portal_id[]" value="" /><input class="f-portal-nome" name="f_portal_nome[]" value="" /><input class="f-portal-uid" name="f_portal_uid[]" value="" class="f-portal-uid" /><a href="" class="remove_op_categoria" title="remover este campo">[x]</a>');
        mndti.remove_elemento('.remove_op_categoria', 'p');
        
        
    },
}

// JQUERY LOADING
$(document).ready(function() { mndti.all(); });





/* Script Adptado por ThiagoInfo  - Cpia Proibida */

var Validar = {
	isEmail : function(s) {
		return this.test(s, '^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+@[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$');
	},

	isAbsUrl : function(s) {
		return this.test(s, '^(news|telnet|nttp|file|http|ftp|https)://[-A-Za-z0-9\\.]+\\/?.*$');
	},

	isSize : function(s) {
		return this.test(s, '^[0-9]+(%|in|cm|mm|em|ex|pt|pc|px)?$');
	},

	isId : function(s) {
		return this.test(s, '^[A-Za-z_]([A-Za-z0-9_])*$');
	},

	isEmpty : function(s) {
		var nl, i;

		if (s.nodeName == 'SELECT' && s.options[s.selectedIndex].value == 'Selecione')
			return true;
		if ((s.nodeName == 'INPUT' && s.value == '') || (s.nodeName == 'INPUT' && s.value == 'http://'))
			return true;
		if (s.nodeName == 'TEXTAREA' && s.value == '')
			return true;

		if (s.type == 'checkbox' && !s.checked)
			return true;

		if (s.type == 'radio') {
			for (i=0, nl = s.form.elements; i<nl.length; i++) {
				if (nl[i].type == "radio" && nl[i].name == s.name && nl[i].checked)
					return false;
			}

			return true;
		}

		return new RegExp('^\\s*$').test(s.nodeType == 1 ? s.value : s);
	},
	test : function(s, p) {
		s = s.nodeType == 1 ? s.value : s;

		return s == '' || new RegExp(p).test(s);
	}
};

var AutoValidar = {
	settings : {
		id_cls : 'id',
		int_cls : 'int',
		url_cls : 'url',
		number_cls : 'number',
		email_cls : 'email',
		size_cls : 'size',
		required_cls : 'requerido',
		invalid_cls : 'invalido',
		min_cls : 'min',
		max_cls : 'max',
		verificado_cls : 'verificado'
	},

	init : function(s) {
		var n;

		for (n in s)
			this.settings[n] = s[n];
	},

	valida : function(f) {
		var i, nl, s = this.settings, c = 0;

		nl = this.tags(f, 'label');
		for (i=0; i<nl.length; i++)
			this.removeClass(nl[i], s.invalid_cls);
			

		c += this.validaElms(f, 'input');
		c += this.validaElms(f, 'select');
		c += this.validaElms(f, 'textarea');

		return c == 3;
	},

	invalidate : function(n) {
		this.mark(n.form, n);
	},

	limpa : function(e) {
		var t = ['label', 'input', 'select', 'textarea'];
		var i, j, nl, s = this.settings;

		if (e == null)
			return;

		for (i=0; i<t.length; i++) {
			nl = this.tags(e.form ? e.form : e, t[i]);
			for (j=0; j<nl.length; j++){
				this.removeClass(nl[j], s.invalid_cls);
				this.removeClass(nl[j], s.verificado_cls);				
			}
				
		}
	},

	validaElms : function(f, e) {
		var nl, i, n, s = this.settings, st = true, va = Validar, v;

		nl = this.tags(f, e);
		for (i=0; i<nl.length; i++) {
			n = nl[i];

			this.removeClass(n, s.invalid_cls);
			
			
			if (this.removeClass(n, s.invalid_cls) && this.hasClass(n, s.required_cls)){
				this.addClass(n, s.verificado_cls);
			}

			if (this.hasClass(n, s.required_cls) && va.isEmpty(n))
				st = this.mark(f, n);			
				
			if (this.hasClass(n, s.number_cls) && !va.isNumber(n))
				st = this.mark(f, n);

			if (this.hasClass(n, s.int_cls) && !va.isNumber(n, true))
				st = this.mark(f, n);

			if (this.hasClass(n, s.url_cls) && !va.isAbsUrl(n))
				st = this.mark(f, n);

			if (this.hasClass(n, s.email_cls) && !va.isEmail(n))
				st = this.mark(f, n);
				
			if (this.hasClass(n, s.size_cls) && !va.isSize(n))
				st = this.mark(f, n);

			if (this.hasClass(n, s.id_cls) && !va.isId(n))
				st = this.mark(f, n);

			if (this.hasClass(n, s.min_cls, true)) {
				v = this.getNum(n, s.min_cls);

				if (isNaN(v) || parseInt(n.value) < parseInt(v))
					st = this.mark(f, n);
			}

			if (this.hasClass(n, s.max_cls, true)) {
				v = this.getNum(n, s.max_cls);

				if (isNaN(v) || parseInt(n.value) > parseInt(v))
					st = this.mark(f, n);
			}
		}

		return st;
	},

	hasClass : function(n, c, d) {
		return new RegExp('\\b' + c + (d ? '[0-9]+' : '') + '\\b', 'g').test(n.className);
	},

	getNum : function(n, c) {
		c = n.className.match(new RegExp('\\b' + c + '([0-9]+)\\b', 'g'))[0];
		c = c.replace(/[^0-9]/g, '');

		return c;
	},

	addClass : function(n, c, b) {
		var o = this.removeClass(n, c);
		n.className = b ? c + (o != '' ? (' ' + o) : '') : (o != '' ? (o + ' ') : '') + c;
	},

	removeClass : function(n, c) {
		c = n.className.replace(new RegExp("(^|\\s+)" + c + "(\\s+|$)"), ' ');
		return n.className = c != ' ' ? c : '';
	},

	tags : function(f, s) {
		return f.getElementsByTagName(s);
	},

	mark : function(f, n) {
		var s = this.settings;

		this.addClass(n, s.invalid_cls);
		this.markLabels(f, n, s.invalid_cls);

		return false;
	},
	markLabels : function(f, n, ic) {
		var nl, i;

		nl = this.tags(f, "label");
		for (i=0; i<nl.length; i++) {
			if (nl[i].getAttribute("for") == n.id || nl[i].htmlFor == n.id)
				this.addClass(nl[i], ic);
		}

		return null;
	}
};